3 # Copyright (C) The Arvados Authors. All rights reserved.
5 # SPDX-License-Identifier: CC-BY-SA-3.0
7 # If you want to test arvados in a single host, you can run this script, which
8 # will install it using salt masterless
9 # This script is run by the Vagrant file when you run it with
15 # capture the directory that the script is running from
16 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
20 echo >&2 "Usage: ${0} [-h] [-h]"
22 echo >&2 "${0} options:"
23 echo >&2 " -d, --debug Run salt installation in debug mode"
24 echo >&2 " -c <local.params>, --config <local.params> Path to the local.params config file"
25 echo >&2 " -t, --test Test installation running a CWL workflow"
26 echo >&2 " -r, --roles List of Arvados roles to apply to the host, comma separated"
27 echo >&2 " Possible values are:"
29 echo >&2 " controller"
30 echo >&2 " dispatcher"
38 echo >&2 " workbench2"
39 echo >&2 " Defaults to applying them all"
40 echo >&2 " -h, --help Display this help and exit"
41 echo >&2 " --dump-config <dest_dir> Dumps the pillars and states to a directory"
42 echo >&2 " This parameter does not perform any installation at all. It's"
43 echo >&2 " intended to give you a parsed sot of configuration files so"
44 echo >&2 " you can inspect them or use them in you Saltstack infrastructure."
46 echo >&2 " - parses the pillar and states templates,"
47 echo >&2 " - downloads the helper formulas with their desired versions,"
48 echo >&2 " - prepares the 'top.sls' files both for pillars and states"
49 echo >&2 " for the selected role/s"
50 echo >&2 " - writes the resulting files into <dest_dir>"
51 echo >&2 " -v, --vagrant Run in vagrant and use the /vagrant shared dir"
52 echo >&2 " --development Run in dev mode, using snakeoil certs"
57 # NOTE: This requires GNU getopt (part of the util-linux package on Debian-based distros).
58 if ! which getopt > /dev/null; then
59 echo >&2 "GNU getopt is required to run this script. Please install it and re-reun it"
63 TEMP=$(getopt -o c:dhp:r:tv \
64 --long config:,debug,development,dump-config:,help,roles:,test,vagrant \
68 then echo "Please check the parameters you entered and re-run again"
71 # Note the quotes around `$TEMP': they are essential!
74 while [ ${#} -ge 1 ]; do
86 if [[ ${2} = /* ]]; then
87 DUMP_SALT_CONFIG_DIR=${2}
89 DUMP_SALT_CONFIG_DIR=${PWD}/${2}
92 S_DIR="${DUMP_SALT_CONFIG_DIR}/salt"
94 F_DIR="${DUMP_SALT_CONFIG_DIR}/formulas"
96 P_DIR="${DUMP_SALT_CONFIG_DIR}/pillars"
98 T_DIR="${DUMP_SALT_CONFIG_DIR}/tests"
109 # Verify the role exists
110 if [[ ! "database,api,controller,keepstore,websocket,keepweb,workbench2,webshell,keepproxy,shell,workbench,dispatcher" == *"$i"* ]]; then
111 echo "The role '${i}' is not a valid role"
115 ROLES="${ROLES} ${i}"
143 mkdir -p /srv/salt/certs
145 if [ -f ${cert_dir}/${cert_name}.crt ]; then
146 cp -v ${cert_dir}/${cert_name}.crt /srv/salt/certs/arvados-${cert_name}.pem
148 echo "${cert_dir}/${cert_name}.crt does not exist. Exiting"
151 if [ -f ${cert_dir}/${cert_name}.key ]; then
152 cp -v ${cert_dir}/${cert_name}.key /srv/salt/certs/arvados-${cert_name}.key
154 echo "${cert_dir}/${cert_name}.key does not exist. Exiting"
160 CONFIG_FILE="${SCRIPT_DIR}/local.params"
161 CONFIG_DIR="local_config_dir"
164 CONTROLLER_EXT_SSL_PORT=443
170 # Hostnames/IPs used for single-host deploys
175 INITIAL_USER_EMAIL=""
176 INITIAL_USER_PASSWORD=""
178 CONTROLLER_EXT_SSL_PORT=8000
179 KEEP_EXT_SSL_PORT=25101
180 # Both for collections and downloads
181 KEEPWEB_EXT_SSL_PORT=9002
182 WEBSHELL_EXT_SSL_PORT=4202
183 WEBSOCKET_EXT_SSL_PORT=8002
184 WORKBENCH1_EXT_SSL_PORT=443
185 WORKBENCH2_EXT_SSL_PORT=3001
187 SSL_MODE="self-signed"
188 USE_LETSENCRYPT_ROUTE53="no"
189 CUSTOM_CERTS_DIR="${SCRIPT_DIR}/certs"
191 ## These are ARVADOS-related parameters
192 # For a stable release, change RELEASE "production" and VERSION to the
193 # package version (including the iteration, e.g. X.Y.Z-1) of the
195 # The "local.params.example.*" files already set "RELEASE=production"
196 # to deploy production-ready packages
197 RELEASE="development"
200 # These are arvados-formula-related parameters
201 # An arvados-formula tag. For a stable release, this should be a
202 # branch name (e.g. X.Y-dev) or tag for the release.
203 # ARVADOS_TAG="2.2.0"
206 # Other formula versions we depend on
207 POSTGRES_TAG="v0.44.0"
211 LETSENCRYPT_TAG="v2.1.0"
214 DUMP_SALT_CONFIG_DIR=""
218 F_DIR="/srv/formulas"
222 T_DIR="/tmp/cluster_tests"
226 if [ -s ${CONFIG_FILE} ]; then
227 source ${CONFIG_FILE}
229 echo >&2 "You don't seem to have a config file with initial values."
230 echo >&2 "Please create a '${CONFIG_FILE}' file as described in"
231 echo >&2 " * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
232 echo >&2 " * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
236 if [ ! -d ${CONFIG_DIR} ]; then
237 echo >&2 "You don't seem to have a config directory with pillars and states."
238 echo >&2 "Please create a '${CONFIG_DIR}' directory (as configured in your '${CONFIG_FILE}'). Please see"
239 echo >&2 " * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
240 echo >&2 " * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
244 if grep -q 'fixme_or_this_wont_work' ${CONFIG_FILE} ; then
245 echo >&2 "The config file ${CONFIG_FILE} has some parameters that need to be modified."
246 echo >&2 "Please, fix them and re-run the provision script."
250 if ! grep -qE '^[[:alnum:]]{5}$' <<<${CLUSTER} ; then
251 echo >&2 "ERROR: <CLUSTER> must be exactly 5 alphanumeric characters long"
252 echo >&2 "Fix the cluster name in the 'local.params' file and re-run the provision script"
256 # Only used in single_host/single_name deploys
257 if [ ! -z "${HOSTNAME_EXT}" ] ; then
258 # We need to add some extra control vars to manage a single certificate vs. multiple
259 USE_SINGLE_HOSTNAME="yes"
260 # Make sure that the value configured as IP_INT is a real IP on the system.
261 # If we don't error out early here when there is a mismatch, the formula will
262 # fail with hard to interpret nginx errors later on.
263 ip addr list |grep -q " ${IP_INT}/"
264 if [[ $? -ne 0 ]]; then
265 echo "Unable to find the IP_INT address '${IP_INT}' on the system, please correct the value in local.params. Exiting..."
269 USE_SINGLE_HOSTNAME="no"
270 # We set this variable, anyway, so sed lines do not fail and we don't need to add more
272 HOSTNAME_EXT="${CLUSTER}.${DOMAIN}"
275 if [ "${DUMP_CONFIG}" = "yes" ]; then
276 echo "The provision installer will just dump a config under ${DUMP_SALT_CONFIG_DIR} and exit"
278 # Install a few dependency packages
279 # First, let's figure out the OS we're working on
280 OS_ID=$(grep ^ID= /etc/os-release |cut -f 2 -d= |cut -f 2 -d \")
281 echo "Detected distro: ${OS_ID}"
285 echo "WARNING! Disabling SELinux, see https://dev.arvados.org/issues/18019"
286 sed -i 's/SELINUX=enforcing/SELINUX=permissive' /etc/sysconfig/selinux
287 setenforce permissive
288 yum install -y curl git jq
291 DEBIAN_FRONTEND=noninteractive apt update
292 DEBIAN_FRONTEND=noninteractive apt install -y curl git jq
296 if which salt-call; then
297 echo "Salt already installed"
299 curl -L https://bootstrap.saltstack.com -o /tmp/bootstrap_salt.sh
300 sh /tmp/bootstrap_salt.sh -XdfP -x python3
301 /bin/systemctl stop salt-minion.service
302 /bin/systemctl disable salt-minion.service
305 # Set salt to masterless mode
306 cat > /etc/salt/minion << EOFSM
321 mkdir -p ${S_DIR} ${F_DIR} ${P_DIR} ${T_DIR}
323 # Get the formula and dependencies
324 cd ${F_DIR} || exit 1
325 echo "Cloning formulas"
326 rm -rf ${F_DIR}/* || exit 1
327 git clone --quiet https://github.com/saltstack-formulas/docker-formula.git ${F_DIR}/docker
328 ( cd docker && git checkout --quiet tags/"${DOCKER_TAG}" -b "${DOCKER_TAG}" )
331 git clone --quiet https://github.com/saltstack-formulas/locale-formula.git ${F_DIR}/locale
332 ( cd locale && git checkout --quiet tags/"${LOCALE_TAG}" -b "${LOCALE_TAG}" )
335 git clone --quiet https://github.com/saltstack-formulas/nginx-formula.git ${F_DIR}/nginx
336 ( cd nginx && git checkout --quiet tags/"${NGINX_TAG}" -b "${NGINX_TAG}" )
339 git clone --quiet https://github.com/saltstack-formulas/postgres-formula.git ${F_DIR}/postgres
340 ( cd postgres && git checkout --quiet tags/"${POSTGRES_TAG}" -b "${POSTGRES_TAG}" )
342 echo "...letsencrypt"
343 git clone --quiet https://github.com/saltstack-formulas/letsencrypt-formula.git ${F_DIR}/letsencrypt
344 ( cd letsencrypt && git checkout --quiet tags/"${LETSENCRYPT_TAG}" -b "${LETSENCRYPT_TAG}" )
347 git clone --quiet https://git.arvados.org/arvados-formula.git ${F_DIR}/arvados
349 # If we want to try a specific branch of the formula
350 if [ "x${BRANCH}" != "x" ]; then
351 ( cd ${F_DIR}/arvados && git checkout --quiet -t origin/"${BRANCH}" -b "${BRANCH}" )
352 elif [ "x${ARVADOS_TAG}" != "x" ]; then
353 ( cd ${F_DIR}/arvados && git checkout --quiet tags/"${ARVADOS_TAG}" -b "${ARVADOS_TAG}" )
356 if [ "x${VAGRANT}" = "xyes" ]; then
357 EXTRA_STATES_DIR="/home/vagrant/${CONFIG_DIR}/states"
358 SOURCE_PILLARS_DIR="/home/vagrant/${CONFIG_DIR}/pillars"
359 SOURCE_TESTS_DIR="/home/vagrant/${TESTS_DIR}"
361 EXTRA_STATES_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/states"
362 SOURCE_PILLARS_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/pillars"
363 SOURCE_TESTS_DIR="${SCRIPT_DIR}/${TESTS_DIR}"
366 SOURCE_STATES_DIR="${EXTRA_STATES_DIR}"
368 echo "Writing pillars and states"
370 # Replace variables (cluster, domain, etc) in the pillars, states and tests
371 # to ease deployment for newcomers
372 if [ ! -d "${SOURCE_PILLARS_DIR}" ]; then
373 echo "${SOURCE_PILLARS_DIR} does not exist or is not a directory. Exiting."
376 for f in $(ls "${SOURCE_PILLARS_DIR}"/*); do
377 sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
378 s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
379 s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
380 s#__CLUSTER__#${CLUSTER}#g;
381 s#__DOMAIN__#${DOMAIN}#g;
382 s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
383 s#__IP_INT__#${IP_INT}#g;
384 s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
385 s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
386 s#__INITIAL_USER__#${INITIAL_USER}#g;
387 s#__LE_AWS_REGION__#${LE_AWS_REGION}#g;
388 s#__LE_AWS_SECRET_ACCESS_KEY__#${LE_AWS_SECRET_ACCESS_KEY}#g;
389 s#__LE_AWS_ACCESS_KEY_ID__#${LE_AWS_ACCESS_KEY_ID}#g;
390 s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
391 s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
392 s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
393 s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
394 s#__RELEASE__#${RELEASE}#g;
395 s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
396 s#__VERSION__#${VERSION}#g;
397 s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
398 s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
399 s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
400 s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
401 s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
402 s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
403 s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
404 s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
405 s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
406 s#__KEEPSTORE1_INT_IP__#${KEEPSTORE1_INT_IP}#g;
407 s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
408 s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
409 s#__SHELL_INT_IP__#${SHELL_INT_IP}#g;
410 s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
411 s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
412 s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
413 s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g" \
414 "${f}" > "${P_DIR}"/$(basename "${f}")
417 if [ "x${TEST}" = "xyes" ] && [ ! -d "${SOURCE_TESTS_DIR}" ]; then
418 echo "You requested to run tests, but ${SOURCE_TESTS_DIR} does not exist or is not a directory. Exiting."
422 # Replace cluster and domain name in the test files
423 for f in $(ls "${SOURCE_TESTS_DIR}"/*); do
424 FILTERS="s#__CLUSTER__#${CLUSTER}#g;
425 s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
426 s#__DOMAIN__#${DOMAIN}#g;
427 s#__IP_INT__#${IP_INT}#g;
428 s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
429 s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g
430 s#__INITIAL_USER__#${INITIAL_USER}#g;
431 s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
432 s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g"
433 if [ "$USE_SINGLE_HOSTNAME" = "yes" ]; then
434 FILTERS="s#__CLUSTER__.__DOMAIN__#${HOSTNAME_EXT}#g;
438 "${f}" > ${T_DIR}/$(basename "${f}")
440 chmod 755 ${T_DIR}/run-test.sh
442 # Replace helper state files that differ from the formula's examples
443 if [ -d "${SOURCE_STATES_DIR}" ]; then
444 mkdir -p "${F_DIR}"/extra/extra
446 for f in $(ls "${SOURCE_STATES_DIR}"/*); do
447 sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
448 s#__CLUSTER__#${CLUSTER}#g;
449 s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
450 s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
451 s#__DOMAIN__#${DOMAIN}#g;
452 s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
453 s#__IP_INT__#${IP_INT}#g;
454 s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
455 s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
456 s#__INITIAL_USER__#${INITIAL_USER}#g;
457 s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
458 s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
459 s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
460 s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
461 s#__RELEASE__#${RELEASE}#g;
462 s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
463 s#__VERSION__#${VERSION}#g;
464 s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
465 s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
466 s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
467 s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
468 s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
469 s#__KEEPSTORE1_INT_IP__#${KEEPSTORE1_INT_IP}#g;
470 s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
471 s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
472 s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
473 s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
474 s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
475 s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
476 s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
477 s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
478 s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
479 s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g" \
480 "${f}" > "${F_DIR}/extra/extra"/$(basename "${f}")
484 # Now, we build the SALT states/pillars trees
485 # As we need to separate both states and pillars in case we want specific
486 # roles, we iterate on both at the same time
489 cat > ${S_DIR}/top.sls << EOFTSLS
496 cat > ${P_DIR}/top.sls << EOFPSLS
503 # States, extra states
504 if [ -d "${F_DIR}"/extra/extra ]; then
505 SKIP_SNAKE_OIL="snakeoil_certs"
507 if [[ "$DEV_MODE" = "yes" || "${SSL_MODE}" == "self-signed" ]] ; then
508 # In dev mode, we create some snake oil certs that we'll
509 # use as CUSTOM_CERTS, so we don't skip the states file.
510 # Same when using self-signed certificates.
511 SKIP_SNAKE_OIL="dont_add_snakeoil_certs"
513 for f in $(ls "${F_DIR}"/extra/extra/*.sls | grep -v ${SKIP_SNAKE_OIL}); do
514 echo " - extra.$(basename ${f} | sed 's/.sls$//g')" >> ${S_DIR}/top.sls
516 # Use byo or self-signed certificates
517 if [ "${SSL_MODE}" != "lets-encrypt" ]; then
518 mkdir -p "${F_DIR}"/extra/extra/files
522 # If we want specific roles for a node, just add the desired states
523 # and its dependencies
524 if [ -z "${ROLES}" ]; then
526 echo " - nginx.passenger" >> ${S_DIR}/top.sls
527 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
528 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
529 grep -q "aws_credentials" ${S_DIR}/top.sls || echo " - extra.aws_credentials" >> ${S_DIR}/top.sls
531 grep -q "letsencrypt" ${S_DIR}/top.sls || echo " - letsencrypt" >> ${S_DIR}/top.sls
533 # Use custom certs, as both bring-your-own and self-signed are copied using this state
534 # Copy certs to formula extra/files
535 # In dev mode, the files will be created and put in the destination directory by the
536 # snakeoil_certs.sls state file
537 mkdir -p /srv/salt/certs
538 cp -rv ${CUSTOM_CERTS_DIR}/* /srv/salt/certs/
539 # We add the custom_certs state
540 grep -q "custom_certs" ${S_DIR}/top.sls || echo " - extra.custom_certs" >> ${S_DIR}/top.sls
543 echo " - postgres" >> ${S_DIR}/top.sls
544 echo " - docker.software" >> ${S_DIR}/top.sls
545 echo " - arvados" >> ${S_DIR}/top.sls
548 echo " - docker" >> ${P_DIR}/top.sls
549 echo " - nginx_api_configuration" >> ${P_DIR}/top.sls
550 echo " - nginx_controller_configuration" >> ${P_DIR}/top.sls
551 echo " - nginx_keepproxy_configuration" >> ${P_DIR}/top.sls
552 echo " - nginx_keepweb_configuration" >> ${P_DIR}/top.sls
553 echo " - nginx_passenger" >> ${P_DIR}/top.sls
554 echo " - nginx_websocket_configuration" >> ${P_DIR}/top.sls
555 echo " - nginx_webshell_configuration" >> ${P_DIR}/top.sls
556 echo " - nginx_workbench2_configuration" >> ${P_DIR}/top.sls
557 echo " - nginx_workbench_configuration" >> ${P_DIR}/top.sls
558 echo " - postgresql" >> ${P_DIR}/top.sls
560 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
561 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
562 grep -q "aws_credentials" ${P_DIR}/top.sls || echo " - aws_credentials" >> ${P_DIR}/top.sls
564 grep -q "letsencrypt" ${P_DIR}/top.sls || echo " - letsencrypt" >> ${P_DIR}/top.sls
566 # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
567 for c in controller websocket workbench workbench2 webshell download collections keepproxy; do
568 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${c}.${CLUSTER}.${DOMAIN}*/g;
569 s#__CERT_PEM__#/etc/letsencrypt/live/${c}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
570 s#__CERT_KEY__#/etc/letsencrypt/live/${c}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
571 ${P_DIR}/nginx_${c}_configuration.sls
574 # Use custom certs (either dev mode or prod)
575 grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo " - extra_custom_certs" >> ${P_DIR}/top.sls
576 # And add the certs in the custom_certs pillar
577 echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
578 echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
580 for c in controller websocket workbench workbench2 webshell keepweb keepproxy; do
581 # Are we in a single-host-single-hostname env?
582 if [ "${USE_SINGLE_HOSTNAME}" = "yes" ]; then
583 # Are we in a single-host-single-hostname env?
584 CERT_NAME=${HOSTNAME_EXT}
586 # We are in a multiple-hostnames env
590 if [[ "$SSL_MODE" == "bring-your-own" ]]; then
591 copy_custom_cert ${CUSTOM_CERTS_DIR} ${CERT_NAME}
594 grep -q ${CERT_NAME} ${P_DIR}/extra_custom_certs.sls || echo " - ${CERT_NAME}" >> ${P_DIR}/extra_custom_certs.sls
596 # As the pillar differs whether we use LE or custom certs, we need to do a final edition on them
597 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${CERT_NAME}.pem/g;
598 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${CERT_NAME}.pem#g;
599 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${CERT_NAME}.key#g" \
600 ${P_DIR}/nginx_${c}_configuration.sls
604 # If we add individual roles, make sure we add the repo first
605 echo " - arvados.repo" >> ${S_DIR}/top.sls
606 # We add the extra_custom_certs state
607 grep -q "extra.custom_certs" ${S_DIR}/top.sls || echo " - extra.custom_certs" >> ${S_DIR}/top.sls
609 # And we add the basic part for the certs pillar
610 if [ "${SSL_MODE}" != "lets-encrypt" ]; then
611 # And add the certs in the custom_certs pillar
612 echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
613 echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
614 grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo " - extra_custom_certs" >> ${P_DIR}/top.sls
617 for R in ${ROLES}; do
621 echo " - postgres" >> ${S_DIR}/top.sls
623 echo ' - postgresql' >> ${P_DIR}/top.sls
627 # FIXME: https://dev.arvados.org/issues/17352
628 grep -q "postgres.client" ${S_DIR}/top.sls || echo " - postgres.client" >> ${S_DIR}/top.sls
629 grep -q "nginx.passenger" ${S_DIR}/top.sls || echo " - nginx.passenger" >> ${S_DIR}/top.sls
630 ### If we don't install and run LE before arvados-api-server, it fails and breaks everything
631 ### after it. So we add this here as we are, after all, sharing the host for api and controller
632 # Currently, only available on config_examples/multi_host/aws
633 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
634 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
635 grep -q "aws_credentials" ${S_DIR}/top.sls || echo " - aws_credentials" >> ${S_DIR}/top.sls
637 grep -q "letsencrypt" ${S_DIR}/top.sls || echo " - letsencrypt" >> ${S_DIR}/top.sls
640 if [ "${SSL_MODE}" = "bring-your-own" ]; then
641 copy_custom_cert ${CUSTOM_CERTS_DIR} controller
643 grep -q controller ${P_DIR}/extra_custom_certs.sls || echo " - controller" >> ${P_DIR}/extra_custom_certs.sls
645 grep -q "arvados.${R}" ${S_DIR}/top.sls || echo " - arvados.${R}" >> ${S_DIR}/top.sls
647 grep -q "aws_credentials" ${P_DIR}/top.sls || echo " - aws_credentials" >> ${P_DIR}/top.sls
648 grep -q "postgresql" ${P_DIR}/top.sls || echo " - postgresql" >> ${P_DIR}/top.sls
649 grep -q "nginx_passenger" ${P_DIR}/top.sls || echo " - nginx_passenger" >> ${P_DIR}/top.sls
650 grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo " - nginx_${R}_configuration" >> ${P_DIR}/top.sls
652 "controller" | "websocket" | "workbench" | "workbench2" | "webshell" | "keepweb" | "keepproxy")
654 grep -q "nginx.passenger" ${S_DIR}/top.sls || echo " - nginx.passenger" >> ${S_DIR}/top.sls
655 # Currently, only available on config_examples/multi_host/aws
656 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
657 if [ "x${USE_LETSENCRYPT_ROUTE53}" = "xyes" ]; then
658 grep -q "aws_credentials" ${S_DIR}/top.sls || echo " - aws_credentials" >> ${S_DIR}/top.sls
660 grep -q "letsencrypt" ${S_DIR}/top.sls || echo " - letsencrypt" >> ${S_DIR}/top.sls
662 # Use custom certs, special case for keepweb
663 if [ ${R} = "keepweb" ]; then
664 if [ "${SSL_MODE}" = "bring-your-own" ]; then
665 copy_custom_cert ${CUSTOM_CERTS_DIR} download
666 copy_custom_cert ${CUSTOM_CERTS_DIR} collections
669 if [ "${SSL_MODE}" = "bring-your-own" ]; then
670 copy_custom_cert ${CUSTOM_CERTS_DIR} ${R}
674 # webshell role is just a nginx vhost, so it has no state
675 if [ "${R}" != "webshell" ]; then
676 grep -q "arvados.${R}" ${S_DIR}/top.sls || echo " - arvados.${R}" >> ${S_DIR}/top.sls
679 grep -q "nginx_passenger" ${P_DIR}/top.sls || echo " - nginx_passenger" >> ${P_DIR}/top.sls
680 grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo " - nginx_${R}_configuration" >> ${P_DIR}/top.sls
681 # Special case for keepweb
682 if [ ${R} = "keepweb" ]; then
683 grep -q "nginx_download_configuration" ${P_DIR}/top.sls || echo " - nginx_download_configuration" >> ${P_DIR}/top.sls
684 grep -q "nginx_collections_configuration" ${P_DIR}/top.sls || echo " - nginx_collections_configuration" >> ${P_DIR}/top.sls
687 # Currently, only available on config_examples/multi_host/aws
688 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
689 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
690 grep -q "aws_credentials" ${P_DIR}/top.sls || echo " - aws_credentials" >> ${P_DIR}/top.sls
692 grep -q "letsencrypt" ${P_DIR}/top.sls || echo " - letsencrypt" >> ${P_DIR}/top.sls
693 grep -q "letsencrypt_${R}_configuration" ${P_DIR}/top.sls || echo " - letsencrypt_${R}_configuration" >> ${P_DIR}/top.sls
695 # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
696 # Special case for keepweb
697 if [ ${R} = "keepweb" ]; then
698 for kwsub in download collections; do
699 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${kwsub}.${CLUSTER}.${DOMAIN}*/g;
700 s#__CERT_PEM__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
701 s#__CERT_KEY__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
702 ${P_DIR}/nginx_${kwsub}_configuration.sls
705 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${R}.${CLUSTER}.${DOMAIN}*/g;
706 s#__CERT_PEM__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
707 s#__CERT_KEY__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
708 ${P_DIR}/nginx_${R}_configuration.sls
711 # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
712 # Special case for keepweb
713 if [ ${R} = "keepweb" ]; then
714 for kwsub in download collections; do
715 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${kwsub}.pem/g;
716 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${kwsub}.pem#g;
717 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${kwsub}.key#g" \
718 ${P_DIR}/nginx_${kwsub}_configuration.sls
719 grep -q ${kwsub} ${P_DIR}/extra_custom_certs.sls || echo " - ${kwsub}" >> ${P_DIR}/extra_custom_certs.sls
722 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${R}.pem/g;
723 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${R}.pem#g;
724 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${R}.key#g" \
725 ${P_DIR}/nginx_${R}_configuration.sls
726 grep -q ${R} ${P_DIR}/extra_custom_certs.sls || echo " - ${R}" >> ${P_DIR}/extra_custom_certs.sls
732 grep -q "docker" ${S_DIR}/top.sls || echo " - docker.software" >> ${S_DIR}/top.sls
733 grep -q "arvados.${R}" ${S_DIR}/top.sls || echo " - arvados.${R}" >> ${S_DIR}/top.sls
735 grep -q "docker" ${P_DIR}/top.sls || echo " - docker" >> ${P_DIR}/top.sls
739 grep -q "arvados.${R}" ${S_DIR}/top.sls || echo " - arvados.${R}" >> ${S_DIR}/top.sls
741 # ATM, no specific pillar needed
745 grep -q "arvados.${R}" ${S_DIR}/top.sls || echo " - arvados.${R}" >> ${S_DIR}/top.sls
747 # ATM, no specific pillar needed
750 echo "Unknown role ${R}"
757 if [ "${DUMP_CONFIG}" = "yes" ]; then
758 # We won't run the rest of the script because we're just dumping the config
762 # FIXME! #16992 Temporary fix for psql call in arvados-api-server
763 if [ -e /root/.psqlrc ]; then
764 if ! ( grep 'pset pager off' /root/.psqlrc ); then
766 cp /root/.psqlrc /root/.psqlrc.provision.backup
772 echo '\pset pager off' >> /root/.psqlrc
773 # END FIXME! #16992 Temporary fix for psql call in arvados-api-server
775 # Now run the install
776 salt-call --local state.apply -l ${LOG_LEVEL}
778 # Finally, make sure that /etc/hosts is not overwritten on reboot
779 if [ -d /etc/cloud/cloud.cfg.d ]; then
780 # TODO: will this work on CentOS?
781 sed -i 's/^manage_etc_hosts: true/#manage_etc_hosts: true/g' /etc/cloud/cloud.cfg.d/*
784 # FIXME! #16992 Temporary fix for psql call in arvados-api-server
785 if [ "x${DELETE_PSQL}" = "xyes" ]; then
786 echo "Removing .psql file"
790 if [ "x${RESTORE_PSQL}" = "xyes" ]; then
791 echo "Restoring .psql file"
792 mv -v /root/.psqlrc.provision.backup /root/.psqlrc
794 # END FIXME! #16992 Temporary fix for psql call in arvados-api-server
796 # Leave a copy of the Arvados CA so the user can copy it where it's required
797 if [ "$DEV_MODE" = "yes" ]; then
798 echo "Copying the Arvados CA certificate to the installer dir, so you can import it"
799 # If running in a vagrant VM, also add default user to docker group
800 if [ "x${VAGRANT}" = "xyes" ]; then
801 cp /etc/ssl/certs/arvados-snakeoil-ca.pem /vagrant/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.pem
803 echo "Adding the vagrant user to the docker group"
804 usermod -a -G docker vagrant
806 cp /etc/ssl/certs/arvados-snakeoil-ca.pem ${SCRIPT_DIR}/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.pem
810 # Test that the installation finished correctly
811 if [ "x${TEST}" = "xyes" ]; then
813 # If we use RVM, we need to run this with it, or most ruby commands will fail
815 if [ -x /usr/local/rvm/bin/rvm-exec ]; then
816 RVM_EXEC="/usr/local/rvm/bin/rvm-exec"
818 ${RVM_EXEC} ./run-test.sh